#include "mcc_generated_files/mcc.h"

#define TIME_OFF -1
#define TIME_UP 0       
#define TIME_ADC_WAIT 10
#define TIME_ADC_ERR 50
#define JOY_BASE 600
#define DAC_BASE 0x10
#define DAC_HOSEI 20

typedef enum{
    AD_AN10 = 0,
    AD_AN10_WAIT,
    AD_AN11,
    AD_AN11_WAIT        
}ADC_MODE_NO;

uint16_t an10Value;
uint16_t an11Value;
int16_t timAdc;
int16_t timAdcErr;
int16_t timled;
int16_t dac_val;
int16_t dac_hosei;
ADC_MODE_NO adcmode;

void mainTimer(void);
void AdcItr(void);
void mainApp(void);

/* Main application */
void main(void)
{
    SYSTEM_Initialize();
    TMR0_SetInterruptHandler(mainTimer);
    ADC_SetInterruptHandler(AdcItr);    
    INTERRUPT_GlobalInterruptEnable();
    INTERRUPT_PeripheralInterruptEnable();
    
    timAdcErr = TIME_OFF;
    
    while (1)
    {
        mainApp();
    }
}
/* ^C}Ǘ */
void mainTimer(void){
    
    if( timAdc > TIME_UP ){
        --timAdc;
    }
    
    if( timAdcErr > TIME_UP ){
        --timAdcErr;
    }
    
    if( timled > TIME_UP ){
        --timled;
    }    
}
/* C */
void mainApp(void){
    
    if( timAdc == TIME_UP){
        timAdc = TIME_ADC_WAIT;
 
        switch(adcmode){
            case AD_AN10:
                ADC_SelectChannel(channel_AN10);
                ADC_StartConversion();
                adcmode = AD_AN10_WAIT;
                timAdcErr = TIME_ADC_ERR;   
                break;
            case AD_AN10_WAIT:
                //ADϊ҂
                break;
            case AD_AN11:
                ADC_SelectChannel(channel_AN11);
                ADC_StartConversion();
                adcmode = AD_AN11_WAIT;
                timAdcErr = TIME_ADC_ERR;   
                break;
            case AD_AN11_WAIT:
                //ADϊ҂
                break;    
        }
        
        dac_val= an10Value - JOY_BASE;
        dac_hosei = dac_val / DAC_HOSEI;
        if( dac_hosei >= 0x0F){
            dac_hosei = 0x0F;
        }
        dac_hosei = dac_hosei + DAC_BASE;
        DAC_SetOutput(dac_hosei);
    }
    
    if( timled == TIME_UP){
        timled = an11Value/10;
        IO_RB3_Toggle();
    }
    
    if( timAdcErr == TIME_UP){
        timAdcErr = TIME_OFF;
        adcmode = AD_AN10; 
    }
}
/* ADC̊荞 */
void AdcItr(void){
    
    switch(adcmode){
        case AD_AN10_WAIT:
            adcmode = AD_AN11;
            an10Value = ADC_GetConversionResult();
            break;
        case AD_AN11_WAIT:
            adcmode = AD_AN10;
            an11Value = ADC_GetConversionResult();
            break;  
    }
    timAdcErr = TIME_OFF;
}
/* End of File */